#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

typedef long long ll;

const int maxn=5005;
const ll inf=1e18;
int n;
ll a[maxn],b[maxn];
int p[maxn];
ll dp[maxn][maxn];

void read()
{
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i]>>b[i];
    }
    for(int i=1;i<=n;i++)
        cin>>p[i];

    ll ans=0;
    for(int i=1;i<=n;i++)
    {
        for(int t=0;t<i;t++)
        {
            //dp[i][t]=a[i];
            
            for(int t1=0;t1<=t && t1<i-1;t1++)
            {
                dp[i][t]=max(dp[i][t],dp[i-1][t1]+a[i]+b[i]*t);
            }
            
            ans=max(ans,dp[i][t]);
        }
    }
    cout<<ans<<endl;
}

int main()
{
    speed();
    read();
    return 0;
}
